#version 330

// Uniforms
uniform mat4 m_viewModel;
uniform mat4 m_projection;
uniform float f_thickness;	// width of the line
uniform float f_halo;		// width of the halo

// Input
layout (location = 0) in vec3 v_position;
layout (location = 1) in vec2 v_texcoord;
layout (location = 2) in vec3 v_dir;

// Output
out VertexData
{
    vec2 UV;
	vec4 posVS;

} outData;

// Main
void main()
{
    float width = f_thickness + f_halo;

    vec3 viewDir = vec3(m_viewModel[0][2], m_viewModel[1][2], m_viewModel[2][2]);

    vec3 VxD = normalize(cross(viewDir, v_dir));
    vec3 pos = v_position + ( VxD * ((1-v_texcoord.y) - 0.5) * width);

    outData.posVS = m_viewModel * vec4(pos, 1.0);
	outData.UV = v_texcoord;

    gl_Position = m_projection * outData.posVS;
}
