#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include "glwidget.h"
#include "trackfile.h"

#include <QMainWindow>
#include <QTimer>

namespace Ui {
	class MainWindow;
}

/**
 * @brief The main window of the application.
 */
class MainWindow : public QMainWindow
{
		Q_OBJECT

	public:
		/**
		 * @brief Constructs a new main window.
		 * @param the parent widget.
		 */
		explicit MainWindow(QWidget *parent = 0);
		~MainWindow();

	protected slots:
		/**
		 * @brief Displays a dialog to load a data file.
		 */
		void load();

	protected:
		/**
		 * @brief Queries the maximum number of samples supported by the system.
		 * @return the maximum number of samples.
		 */
		int getMaximumSamples();

	private:
		Ui::MainWindow *ui;

		GLWidget* glWidget;
};

#endif // MAINWINDOW_H
